package jp.co.asterisk.asreader.a24d.demoapp.fragments;

import android.app.AlertDialog;
import android.widget.Toast;

import androidx.fragment.app.Fragment;

import jp.co.asterisk.asreader.a24d.demoapp.MainActivity;

public class BaseFragment extends Fragment {

    private Toast mToast = null;

    protected void setTitle(String title) {
        ((MainActivity) requireActivity()).setTitle(title);
    }

    protected void setBackButtonVisibility(int visibility) {
        MainActivity activity = (MainActivity)getActivity();
        if( activity!=null ){
            activity.setBackButtonVisibility(visibility);
        }
    }

    protected void setLeftButtonEnabled(boolean enabled) {
        MainActivity activity = (MainActivity)getActivity();
        if( activity!=null ){
            activity.setBackButtonEnabled(enabled);
        }
    }

    protected void setLeftButtonText(String text) {
        MainActivity activity = (MainActivity)getActivity();
        if( activity!=null ){
            activity.setBackButtonText(text);
        }
    }

//    protected void setAppAutoLaunch(boolean enable) {
//        MainActivity activity = (MainActivity)getActivity();
//        if( activity!=null ){
//            activity.testMetaData(enable);
//        }
//    }

    protected void setRightButtonVisibility(int visibility) {
        MainActivity activity = (MainActivity)getActivity();
        if( activity!=null ){
            activity.setRightButtonVisibility(visibility);
        }
    }

    protected void setRightButtonEnabled(boolean enabled) {
        MainActivity activity = (MainActivity)getActivity();
        if( activity!=null ){
            activity.setRightButtonEnabled(enabled);
        }
    }

    protected void setRightButtonText(String text) {
        MainActivity activity = (MainActivity)getActivity();
        if( activity!=null ){
            activity.setRightButtonText(text);
        }
    }

    protected void showToast(String message) {
        if(mToast != null) mToast.cancel();
        mToast = Toast.makeText(this.getContext(), message, Toast.LENGTH_SHORT);
        mToast.show();
    }

    protected void showProgressDialog() {
        if( getActivity()!=null ) {
            getActivity().runOnUiThread(() -> {
                ProgressDialogFragment.getInstance().setText("Dialog", "Please wait..");
                ProgressDialogFragment.getInstance().show(getParentFragmentManager());
            });
        }
    }

    protected void hideProgressDialog() {
        requireActivity().runOnUiThread(() -> ProgressDialogFragment.getInstance().dismiss());
    }

    protected AlertDialog.Builder createRebootAlertDialog() {

        return new AlertDialog.Builder(getActivity())
                .setTitle("Please reboot the A24D device.")
                .setPositiveButton("OK", (dialog, which) -> dialog.dismiss());
    }

    public void receivedAppStatus(MainActivity.AppStatus status) {

    }

    public void onRightButtonClick() { }

    public void onLeftButtonClick() { }

    public void onConnect(boolean isConnect) { }

    public void onSetReaderSettingSuccess() { }

    public void onDeviceError(String message){ }
}
