package jp.co.asterisk.asreader.a24d.demoapp.fragments;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import jp.co.asterisk.asreader.a24d.demoapp.R;

public class ProgressDialogFragment extends DialogFragment {
    private static final String TAG = "A24D DemoApp" + ProgressDialogFragment.class.getSimpleName();
    private static final String TAG_TEST_DIALOG = "【A24DDemoAppTestDialog】" + ProgressDialogFragment.class.getSimpleName();

    private static ProgressDialogFragment mInstance = null;
    private String mTitle = "";
    private String mMessage = "";

    private ProgressDialogFragment() {
    }

    public static ProgressDialogFragment getInstance() {
        if( mInstance==null ) {
            Log.d(TAG_TEST_DIALOG, "New");
            mInstance = new ProgressDialogFragment();
        }
        return mInstance;
    }

    public void setText(String title, String message) {
        mTitle = title;
        mMessage = message;
    }

    public void show (@NonNull FragmentManager manager) {
        if(mTitle != null) {
            try {
                super.show(manager, mTitle);
            } catch (IllegalStateException e) {
                e.printStackTrace();
            }
        }
    }

    public void dismiss () {
        try {
            super.dismiss();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//        Log.d(TAG_TEST_DIALOG, "onCreate");
    }

    @NonNull
    @Override
    public Dialog onCreateDialog(@Nullable Bundle savedInstanceState) {
//        Log.d(TAG_TEST_DIALOG, "onCreateDialog");
        AlertDialog.Builder builder = new AlertDialog.Builder(requireActivity());
        LayoutInflater inflater = (LayoutInflater) requireActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View content = inflater.inflate(R.layout.progress_dialog_layout, null);

        TextView textView = content.findViewById(R.id.message_text_view);
        textView.setText(mMessage);
        builder.setView(content);

        setCancelable(false);

        // Create the AlertDialog object and return it
        return builder.create();
    }

    @Override
    public void show(@NonNull FragmentManager manager, @Nullable String tag) {
        Log.d(TAG_TEST_DIALOG, "show");
        try {
            FragmentTransaction ft = manager.beginTransaction();
            ft.add(this, tag);
            ft.commit();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        }
    }
}
