package jp.co.asterisk.asreader.a24d.demoapp.util;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import java.util.ArrayList;

import jp.co.asterisk.asreader.a24d.demoapp.R;

public class BarcodeDataListAdapter extends BaseAdapter {
    LayoutInflater mInflater;
    private ArrayList<BarcodeData> mDataList;

    public BarcodeDataListAdapter(Context context) {
        mInflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    public void setDataList(ArrayList<BarcodeData> dataList) {
        this.mDataList = dataList;
    }

    @Override
    public int getCount() {
        return mDataList.size();
    }

    @Override
    public Object getItem(int position) {
        return mDataList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    @NonNull
    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {
        if (convertView == null) {
            convertView = mInflater.inflate(R.layout.list_item_barcode, parent, false);
        }

        BarcodeData data = (BarcodeData) getItem(position);
        String displayText = "";
        if( data.getCharacterCodeID()!=null && data.getCharacterCodeID().length()>0 ) {
            displayText = "[CodeID : " + data.getCharacterCodeID() + "]";
        }
        if( data.getPrefix()!=null && data.getPrefix().length()>0 ) {
            displayText = displayText + "  [Prefix : " + data.getPrefix() + "]";
        }
        if( data.getSuffix1()!=null && data.getSuffix1().length()>0 ) {
            displayText = displayText + "  [Suffix1 : " + data.getSuffix1() + "]";
        }
        if( data.getSuffix2()!=null && data.getSuffix2().length()>0 ) {
            displayText = displayText + "  [Suffix2 : " + data.getSuffix2() + "]";
        }
        displayText = displayText + "\n";
        displayText = displayText + data.getBarcode();

        TextView dataTextView = convertView.findViewById(R.id.name_text_view);
        TextView countTextView = convertView.findViewById(R.id.count_text_view);

        dataTextView.setText(displayText);
        countTextView.setText(String.valueOf(data.getCount() + 1));

        return convertView;
    }
}
