package jp.co.asterisk.asreader.a24d.demoapp.util;

import android.content.Context;
import android.content.SharedPreferences;

import jp.co.asterisk.asreader.barcodemanager.define.BarcodeConst;

public class SharedPreferencesHelper {
    private static SharedPreferencesHelper instance;
    private final String PREF_KEY_BEEP = "PREF_KEY_BEEP";
    private final String PREF_KEY_VIBRATION = "PREF_KEY_VIBRATION";
    private final String PREF_KEY_LED = "PREF_KEY_LED";
    private final String PREF_KEY_AIMER = "PREF_KEY_AIMER";
    private final String PREF_KEY_POWER_ON_BEEP = "PREF_KEY_POWER_ON_BEEP";
    private final String PREF_KEY_SLEEP_BEEP = "PREF_KEY_SLEEP_BEEP";
//    private final String PREF_KEY_CHARACTER = "PREF_KEY_CHARACTER";
    private final String PREF_KEY_APPLICATION_BEEP = "PREF_KEY_APPLICATION_BEEP";
    private final String PREF_KEY_APP_AUTO_LAUNCH = "PREF_KEY_APP_AUTO_LAUNCH";
    private final String PREF_KEY_HID_MODE = "PREF_KEY_HID_MODE";
    private final String PREF_KEY_BACKGROUND_READ = "PREF_KEY_BACKGROUND_READ";

    private SharedPreferences sharedPreferences;

    private SharedPreferencesHelper() {}

    public static SharedPreferencesHelper getInstance() {
        if (instance == null) instance = new SharedPreferencesHelper();
        return instance;
    }

    public void initialize(Context context) {
        sharedPreferences = context.getSharedPreferences("A24D_APP_DATA", Context.MODE_PRIVATE);
//        sharedPreferences = PreferenceManager.getDefaultSharedPreferences(context);
    }

    public void setBeep(boolean beep) {
        sharedPreferences.edit().putBoolean(PREF_KEY_BEEP, beep).apply();
    }

    public boolean getBeep() {
        return sharedPreferences.getBoolean(PREF_KEY_BEEP, true);
    }

    public void setVibration(boolean vibration) {
        sharedPreferences.edit().putBoolean(PREF_KEY_VIBRATION, vibration).apply();
    }

    public boolean getVibration() {
        return sharedPreferences.getBoolean(PREF_KEY_VIBRATION, true);
    }

    public void setLed(boolean led) {
        sharedPreferences.edit().putBoolean(PREF_KEY_LED, led).apply();
    }

    public boolean getLed() {
        return sharedPreferences.getBoolean(PREF_KEY_LED, true);
    }

    public void setAimer(boolean aimer) {
        sharedPreferences.edit().putBoolean(PREF_KEY_AIMER, aimer).apply();
    }

    public boolean getAimer() {
        return sharedPreferences.getBoolean(PREF_KEY_AIMER, true);
    }

    public void setPowerBeep(boolean powerOnBeep) {
        sharedPreferences.edit().putBoolean(PREF_KEY_POWER_ON_BEEP, powerOnBeep).apply();
    }

    public boolean getPowerBeep() {
        return sharedPreferences.getBoolean(PREF_KEY_POWER_ON_BEEP, true);
    }

    public void setSleepBeep(boolean powerOnBeep) {
        sharedPreferences.edit().putBoolean(PREF_KEY_SLEEP_BEEP, powerOnBeep).apply();
    }

    public boolean getSleepBeep() {
        return sharedPreferences.getBoolean(PREF_KEY_SLEEP_BEEP, true);
    }

//    public void setCharacterSettings(BarcodeConst.BarcodeSettings characterSettings) {
//        sharedPreferences.edit().putString(PREF_KEY_CHARACTER, characterSettings.toString()).apply();
//    }
//
//    public BarcodeConst.BarcodeSettings getCharacterSettings(){
//        String value = sharedPreferences.getString(PREF_KEY_CHARACTER, BarcodeConst.BarcodeSettings.CHARACTER_NONE.toString());
//        try {
//            return BarcodeConst.BarcodeSettings.valueOf(value);
//        } catch (Exception ex) {
//            // For error cases
//            return BarcodeConst.BarcodeSettings.CHARACTER_NONE;
//        }
//    }

    public void setAppAutoLaunch(boolean enable) {
        sharedPreferences.edit().putBoolean(PREF_KEY_APP_AUTO_LAUNCH, enable).apply();
    }

    public boolean getAppAutoLaunch() {
        return sharedPreferences.getBoolean(PREF_KEY_APP_AUTO_LAUNCH, true);
    }

    public void setHidMode(boolean enable) {
        sharedPreferences.edit().putBoolean(PREF_KEY_HID_MODE, enable).apply();
    }

    public boolean getHidMode() {
        return sharedPreferences.getBoolean(PREF_KEY_HID_MODE, true);
    }

    public void setBackgroundRead(boolean enable){
        sharedPreferences.edit().putBoolean(PREF_KEY_BACKGROUND_READ, enable).apply();
    }

    public boolean getBackgroundRead(){
        return sharedPreferences.getBoolean(PREF_KEY_BACKGROUND_READ, false);
    }

    public void setApplicationBeep(SettingConst.ApplicationBeep applicationBeep) {
        sharedPreferences.edit().putString(PREF_KEY_APPLICATION_BEEP, applicationBeep.toString()).apply();
    }

    public SettingConst.ApplicationBeep getApplicationBeep(){
        String value = sharedPreferences.getString(PREF_KEY_APPLICATION_BEEP, SettingConst.ApplicationBeep.BEEP1.toString());
        try {
            return SettingConst.ApplicationBeep.valueOf(value);
        } catch (Exception ex) {
            // For error cases
            return SettingConst.ApplicationBeep.BEEP1;
        }
    }

    private static BarcodeConst.MemoryType toConvertEnum (String string) {
        try {
            return BarcodeConst.MemoryType.valueOf(string);
        } catch (Exception ex) {
            // For error cases
            return BarcodeConst.MemoryType.MEMORY_TYPE_TEMPORARY;
        }
    }

    private static SettingConst.IntoSleepMode toConvertSleepModeEnum (String string) {
        try {
            return SettingConst.IntoSleepMode.valueOf(string);
        } catch (Exception ex) {
            // For error cases
            return SettingConst.IntoSleepMode.MINUTE_5;
        }
    }
}
