package jp.co.asterisk.asreader.a24d.demoapp.util.symbology;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CompoundButton;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import jp.co.asterisk.asreader.a24d.demoapp.R;

import java.util.List;

public class SymbologySettingsRecycleViewAdapter extends RecyclerView.Adapter<SymbologyViewHolder> {

    private List<SymbologyRowData> mSymbologyRowDataList;
    private SymbologySettingsRecycleViewAdapterCallback mCallback;
    private boolean mIsEventEnable = false;
    private SymbologyViewHolder mViewHolder;

    //-----------------------------------------------------------------------------
    //  Constructor
    //-----------------------------------------------------------------------------
    public SymbologySettingsRecycleViewAdapter(List<SymbologyRowData> list) {
        this.mSymbologyRowDataList = list;
    }

    public List<SymbologyRowData> getDataList() { return  this.mSymbologyRowDataList; }
    public void setDataList(List<SymbologyRowData> dataList) { this.mSymbologyRowDataList = dataList; }

    @NonNull
    @Override
    public SymbologyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View inflate = LayoutInflater.from(parent.getContext()).inflate(R.layout.row_symbology, parent, false);
        mViewHolder = new SymbologyViewHolder(inflate);
        return mViewHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull SymbologyViewHolder holder, int position) {
        mViewHolder = holder;
        holder.enableSwitch.setId(position);
        holder.enableSwitch.setText(mSymbologyRowDataList.get(position).getTitle());
        holder.enableSwitch.setChecked(mSymbologyRowDataList.get(position).getSymbologyEnable());
        holder.enableSwitch.setOnCheckedChangeListener(changeListener);
    }

    @Override
    public int getItemCount() {
        return mSymbologyRowDataList.size();
    }

    //-----------------------------------------------------------------------------
    //  Listener
    //-----------------------------------------------------------------------------
    private final CompoundButton.OnCheckedChangeListener changeListener = new CompoundButton.OnCheckedChangeListener() {
        @Override
        public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
            if( mCallback!=null && mIsEventEnable) {
                mCallback.onChangedSwitchCheckStatus(isChecked, mSymbologyRowDataList.get(buttonView.getId()));
            }
        }
    };

    //-----------------------------------------------------------------------------
    //  Public method
    //-----------------------------------------------------------------------------
    public void setCallback(SymbologySettingsRecycleViewAdapterCallback callback) {
        mCallback = callback;
    }

    public void setEventEnable( boolean isEnable) {
        mIsEventEnable = isEnable;
    }
}
